
import java.util.*;
import java.io.*;

abstract class Zamestnanec implements Serializable {
 private String prijmeni, jmeno;
 Zamestnanec(String prijmeni, String jmeno) {
  this.prijmeni = prijmeni;
  this.jmeno = jmeno;
 }
 public String toString() {
  return prijmeni+" "+jmeno;
 }
}

class Manager extends Zamestnanec {
 Sekretarka sekretarka;
 Manager(String prijmeni, String jmeno, Sekretarka sekretarka) {
  super(prijmeni,jmeno);
  this.sekretarka = sekretarka;
 }
 public String toString() {
  return "Manager "+super.toString()+" se sekretarkou "+sekretarka;
 }
}

class Programator extends Zamestnanec {
 final static long serialVersionUID = 1564181691;
 String mobil;
 Programator(String prijmeni, String jmeno) {
  super(prijmeni,jmeno);
 }
 public String toString() {
  return "Programator "+super.toString();
 }
}

class Sekretarka extends Zamestnanec {
 Sekretarka(String prijmeni, String jmeno) {
  super(prijmeni,jmeno);
 }
 public String toString() {
  return "Sekretarka "+super.toString();
 }
}

class Firma implements Serializable {
 private LinkedList zamestnanci;
 Firma() {
  zamestnanci = new LinkedList();
 }
 public void add(Zamestnanec zam) {
  zamestnanci.add(zam);
 }
 public String toString() {
  String result = "";
  Iterator i = zamestnanci.iterator();
  while (i.hasNext()) result+=i.next()+"\n";
  return result;
 }
}

class Store {
 public static void main(String[] args) {
  try {
   Firma firma1 = new Firma();
   Sekretarka sek1 = new Sekretarka("Novakova","Lucie");
   firma1.add(sek1);
   firma1.add(new Manager("Horak","Vaclav",sek1));
   firma1.add(new Programator("Brezina","Karel"));

   System.out.println("BEFORE:");
   System.out.print(firma1);
 
   ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream("firma.dat"));
   out.writeObject(firma1);
   out.close();

   ObjectInputStream in = new ObjectInputStream(new FileInputStream("firma.dat"));
   Firma firma2 = (Firma)in.readObject();
   in.close();

   System.out.println("AFTER:");
   System.out.print(firma2);
  }
  catch(Exception e) {
   System.out.print("exception");
   System.out.println(e);
   e.printStackTrace(System.out);
  }
 }
}
