
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import java.sql.*;
import javax.swing.*;

class ImageCanvas extends Canvas {
 private Image image;
 ImageCanvas(int x, int y) {
  setSize(x,y);
 }
 public void paint(Graphics g) {
  if (image!=null) g.drawImage(image, 0, 0, this);
 }
 public void setImage(Image image) {
  this.image = image;
 }
}

class Viewer extends JFrame implements WindowListener, ActionListener {
 private TextField urlField;
 private ImageCanvas imageCanvas;
 Viewer() {
  imageCanvas = new ImageCanvas(360,270);

  Panel buttons = new Panel();
  Button urlButton = new Button("URL");
  urlButton.addActionListener(this);
  buttons.add(urlButton);
  Button dbButton = new Button("DB");
  dbButton.addActionListener(this);
  buttons.add(dbButton);

  urlField = new TextField("http://cs/figures/kplogo.gif");

  Container content = getContentPane();
  content.add(imageCanvas,BorderLayout.NORTH);
  content.add(buttons,BorderLayout.EAST);
  content.add(urlField,BorderLayout.SOUTH);

  addWindowListener(this);
  pack();
  setVisible(true);
 }
 public void actionPerformed(ActionEvent e) {
  try {
   Image image;
   if (e.getActionCommand().equals("URL")) {
    imageCanvas.setImage(Toolkit.getDefaultToolkit().getImage(new URL(urlField.getText())));
   }
   else if (e.getActionCommand().equals("DB")) {
    Class.forName("oracle.jdbc.driver.OracleDriver");
    String url = "jdbc:oracle:thin:@cs:1526:oracle";
    Connection con = DriverManager.getConnection(url, "ops$valeko", "abc");
    Statement stmt = con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_READ_ONLY);
    PreparedStatement ps = con.prepareStatement("select image from YourTable where popis = ?");
    ps.setString(1, "obr.1");
    
    ResultSet rs = ps.executeQuery();
    rs.next();
    Blob blob = rs.getBlob(1);
    imageCanvas.setImage(Toolkit.getDefaultToolkit().createImage(blob.getBytes(1,(int)blob.length())));
    ps.close();
    con.close();
   }
   imageCanvas.repaint();
  }
  catch (MalformedURLException ex) {
   JOptionPane.showMessageDialog(this, ex, "URL error" , JOptionPane.ERROR_MESSAGE);
  }
  catch (SQLException ex) {
   JOptionPane.showMessageDialog(this, ex, "SQL error" , JOptionPane.ERROR_MESSAGE);
  }
  catch (ClassNotFoundException ex) {
   JOptionPane.showMessageDialog(this, ex, "Driver not found" , JOptionPane.ERROR_MESSAGE);
  }
 }
 public void windowClosing(WindowEvent e) {
  System.exit(0);
 };
 public void windowClosed(WindowEvent e) {};
 public void windowActivated(WindowEvent e) {};
 public void windowDeactivated(WindowEvent e) {};
 public void windowDeiconified(WindowEvent e) {};
 public void windowIconified(WindowEvent e) {};
 public void windowOpened(WindowEvent e) {};
 public static void main(String[] args) {
  Viewer viewer = new Viewer();
 }
}
