
class Net {
 private final boolean array[];
 private int lowest;
 private int threads;
 private int waiting;
 Net(int max) {
  array = new boolean[max];
  lowest = 2;
  threads = 1;
  waiting = 0;
  new Counter(2, this);
 }
 synchronized boolean setDone(int number) {
  if (number>=array.length) {
    threads--;
    notifyAll();
    return false;
  }
  array[number] = true;
  if (number==lowest) {
    while (array[lowest]) {
      lowest++;
      if (lowest>=array.length) {
        threads--;
        notifyAll();
        return false;
      }
    }
    notifyAll();
  }
  while (number>lowest) {
    waiting++;
    if (threads==waiting) {
      threads++;
      new Counter(lowest, this);
    }
    else {
      try { wait(); } catch (InterruptedException e) {}
    }
    waiting--;
  }
  return true;
 }
}

class Counter extends Thread {
 final int step;
 final Net net;
 int actual;
 Counter(int step, Net net) {
  super("Counter "+step);
  this.actual = this.step = step;
  this.net = net;
  System.out.println("Prime number = "+actual);
  start();
 }
 public void run() {
  while (net.setDone(actual)) actual += step;
 }
}

class Erasth extends Thread {
 public static void main(String args[]) {
  new Net(40);
 }
}
