
import java.sql.*;
import java.io.*;

public class StoreDB {

    static void catchWarnings(SQLWarning sqlw) {
	while (sqlw != null) {
	    System.out.println(sqlw);
	    sqlw = sqlw.getNextWarning();
	}
    }

    public static void main(String[] args) {
	try {
	    PrintWriter logWriter = new PrintWriter(new FileOutputStream("log.txt"));
	    DriverManager.setLogWriter(logWriter);

	    Class.forName("oracle.jdbc.driver.OracleDriver");
	    System.out.println("driver loaded...");
	    //String url = "jdbc:oracle:oci8:@ORA8i";
	    //String url = "jdbc:oracle:thin:@oracase:1525:ora8i";
	    String url = "jdbc:oracle:thin:@cs:1526:oracle";

	    Connection con = DriverManager.getConnection(url, "ops$valeko", "***");
      	    System.out.println("connected...");

 	    Statement stmt = con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
						 ResultSet.CONCUR_READ_ONLY);
	
	    System.out.println("statement created...");
	    catchWarnings(con.getWarnings());
	    con.clearWarnings();

	    // (re)create table
	    try { stmt.executeUpdate("drop table YourTable"); }
	    catch (SQLException e) {
		while (e != null) {
		    System.out.println(e);
		    e = e.getNextException();
		}
	    }
	    catchWarnings(stmt.getWarnings());
	    stmt.clearWarnings();

	    stmt.executeUpdate("create table YourTable (popis varchar(6), image blob)");
	    catchWarnings(stmt.getWarnings());
	    stmt.clearWarnings();
	    stmt.close();

	    System.out.println("table YourTable created");

	    // insert values
	    PreparedStatement ps = con.prepareStatement("insert into YourTable values ( ?, ?)");
	    ps.setString(1, "obr.1");
	    File file = new File("obr1.jpeg");
	    FileInputStream fis = new FileInputStream(file);
	    ps.setBinaryStream(2, fis, (int) file.length());
	    ps.executeUpdate();
	    catchWarnings(ps.getWarnings());
	    ps.clearWarnings();
	    
	    // close statement and connection
	    ps.close();
	    con.close();
	}
	catch (FileNotFoundException e) { e.printStackTrace(); }
      	catch (ClassNotFoundException e) { e.printStackTrace(); }
	catch (SQLException e) { e.printStackTrace(); }
	catch (IOException e) { e.printStackTrace(); }
    }
}

