#!/usr/bin/perl

### VARIABLES
my($query,$room,$nick,$host,$port,%rooms,$ref1,$ref2);

### DECODE PARAMETERS
$query = lc $ENV{'QUERY_STRING'};
$query =~ tr/+/ /;
$query =~ s/%(..)/pack('c', hex($1))/eg;

print "Content-Type:text/plain\n\n";

my(%rooms);

table_read(\%rooms,"chat.dat");

my($room) = table_add(\%rooms,$query);
$room or exit;

table_write(\%rooms,"chat.dat");

table_print(\%rooms,$room);

#########################################

sub table_read() {
 my($table, $file) = @_;
 open(CHAT,"<$file");
 while(<CHAT>) {
   chomp();
   table_add($table, $_);
 }
 close(CHAT);
}

sub table_add() {
 my($table, $line) = @_;
 my($room,$nick,$host,$port,$time) = $line =~ /^(\w+) (\w+) ([\d\.]+) (\d+) ?(\d*)$/;
 if ($time) {
   return $room if (abs($time-time)>3600);
 }
 else {
   $time = time;
 }
 @{%{$rooms{$room}}->{$nick}}=($host,$port,$time);
 return $room;
}

sub table_write() {
 my($table, $file) = @_;
 open(CHAT,">$file");
 while (my($room,$ref1) = each %$table) {
  while (my($nick,$ref2) = each %$ref1) {
   my($host,$port,$time) = @$ref2;
   print CHAT "$room $nick $host $port $time\n";
  }
 }
 close(CHAT);
}

sub table_print() {
 my($table, $filter) = @_;
 while (my($nick,$ref2) = each %{%$table->{$filter}}) {
  my($host,$port) = @$ref2;
  print "ITEM $nick $host $port\n";
 }
}
